#!/usr/bin/python
# -*- coding: utf-8 -*-
#
# Based on:
# - http://svn.pardus.org.tr/uludag/trunk/kde3-to-kde4-iconconverter/convert-icon.py
# - http://svn.pardus.org.tr/uludag/trunk/kde3-to-kde4-iconconverter/map
#
# Blames:
# Elan Ruusamäe <glen@pld-linux.org>, 2008-12-09
#
# To run do sth like:
# rm -rf crystalsvg-kde3
# python kde4-kde3-icons.py /usr/share/icons/crystalsvg /usr/share/icons/crystalsvg-kde3 crystalsvg-kde3 map > script
# sh script
# cp kde4-kde3-icons.py map crystalsvg-kde3/
# tar cf crystalsvg-kde3.tar crystalsvg-kde3/
# could do it all in python, but i didn't find a way how to do symlinks in python :)

import sys
import os
import shutil

if len(sys.argv) != 5:
    print "usage: %s kde4-theme-dir kde4-theme-dir new-icon-theme-dir mapfile" % sys.argv[0]
    sys.exit()

kde4themedir = sys.argv[1]
kde3themedir = sys.argv[2]
outthemedir = sys.argv[3]
mapfile = sys.argv[4]

groups = ["actions", "apps", "devices", "filesystems", "mimetypes"]
#sizes = ["16x16", "22x22", "32x32", "48x48", "64x64", "128x128"]
sizes = ["16x16", "22x22", "32x32", "48x48", "64x64", "128x128", "scalable"]

os.mkdir(outthemedir)
for size in sizes:
    for group in groups:
        os.makedirs(os.path.join(outthemedir, size, group))
    for mapline in file(mapfile).readlines():
        if mapline.strip().startswith("#"):
            continue
        oldicon = mapline.split()[1].strip()
        newicon = mapline.split()[0].strip()
        if oldicon == newicon:
            continue

        if not os.path.exists("%s/%s/%s" % (kde4themedir, size, oldicon)):
            continue

        # skip if we already have compat links
        if os.path.exists("%s/%s/%s" % (kde4themedir, size, newicon)) and not os.path.islink("%s/%s/%s" % (kde4themedir, size, newicon)):
            continue

        # didn't exist in kde3 theme? skip
        if not os.path.exists("%s/%s/%s" % (kde3themedir, size, newicon)):
            continue

        (odir, ofile) = oldicon.split('/')
        (ndir, nfile) = newicon.split('/')
        # optimize for shorter links
        if odir == ndir:
            print "ln -s %s %s/%s/%s" % (ofile, outthemedir, size, newicon)
        else:
            print "ln -s ../%s %s/%s/%s" % (oldicon, outthemedir, size, newicon)
